#!/bin/sh

# Kill any running test servers.

running() {
    netstat -lnpt 2>&1 | grep -q '0\.0\.0\.0:8529'
}

kill_server() {
    local pid=$1
    for sig in TERM KILL; do
        running || exit 0
        echo ++ kill -$sig $pid
        kill -$sig $pid
        for i in 1 1 1 4 8 16 29; do
	    running || exit 0
            sleep $i
        done
        running || exit 0
    done
    echo >&2 "warning: unable to kill server $pid"
}

pid=`netstat -lnpt 2>&1 |\
         grep '0\.0\.0\.0:8529' |\
         sed 's:^.* \([0-9]\{1,\}\)/.*$:\1:'`
if echo $pid | grep -q "^[0-9]\{1,\}$"; then
    kill_server $pid
else
    # netstat won't list the pid if it is in a different buildroot --
    # don't ask me why -- so trawl through /proc/ and kill any we find
    for cmdline in /proc/*/cmdline; do
	pid=`echo $cmdline | xargs dirname | xargs basename`
        cmd=`cat /proc/$pid/cmdline 2>/dev/null | tr '\0' ' ' | sed 's: $::'`
	if echo $cmd | grep -q "httpd -d .*/mod_perl-[^/]*/t"; then
	    kill_server $pid
	fi
    done
fi
